diff -cr sendmail-8.9.0/makemap/Build sendmail-8.9.1/makemap/Build
*** sendmail-8.9.0/makemap/Build	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/makemap/Build	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/makemap/Makefile.m4 sendmail-8.9.1/makemap/Makefile.m4
*** sendmail-8.9.0/makemap/Makefile.m4	Tue May 19 16:35:42 1998
--- sendmail-8.9.1/makemap/Makefile.m4	Thu Jun  4 14:27:18 1998
***************
*** 1,7 ****
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.17	(Berkeley)	5/13/98
  #
  
  # C compiler
--- 1,7 ----
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.20	(Berkeley)	6/4/98
  #
  
  # C compiler
***************
*** 57,85 ****
  BEFORE=	confBEFORE safefile.c snprintf.c
  OBJS=	makemap.o safefile.o snprintf.o ${OBJADD}
  
- LINKS=	${DESTDIR}/usr/ucb/newaliases ${DESTDIR}/usr/ucb/mailq
- 
- ALL=	makemap makemap.0
- 
- all: ${ALL}
- 
- makemap: ${BEFORE} ${OBJS}
- 	${CC} -o makemap ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
- 
- safefile.c: ${SRCDIR}/safefile.c
- 	-ln -s ${SRCDIR}/safefile.c safefile.c
- 
- snprintf.c: ${SRCDIR}/snprintf.c
- 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
- 
- undivert(3)
- 
  NROFF=	ifdef(`confNROFF', `confNROFF', `groff -Tascii')
  MANDOC=	ifdef(`confMANDOC', `confMANDOC', `-mandoc')
  
- makemap.0: makemap.8
- 	${NROFF} ${MANDOC} makemap.8 > makemap.0
- 
  INSTALL=ifdef(`confINSTALL', `confINSTALL', `install')
  BINOWN=	ifdef(`confUBINOWN', `confUBINOWN', `bin')
  BINGRP=	ifdef(`confUBINGRP', `confUBINGRP', `bin')
--- 57,65 ----
***************
*** 89,110 ****
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
  install: install-makemap install-docs
  
  install-makemap: makemap
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} makemap ${BINDIR}
  
! install-docs: makemap.0
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} makemap.${MAN8SRC} ${MAN8}/makemap.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} makemap makemap.0
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE', 
--- 69,108 ----
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=${DESTDIR}ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
+ ALL=	makemap makemap.${MAN8SRC}
+ 
+ all: ${ALL}
+ 
+ makemap: ${BEFORE} ${OBJS}
+ 	${CC} -o makemap ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
+ 
+ safefile.c: ${SRCDIR}/safefile.c
+ 	-ln -s ${SRCDIR}/safefile.c safefile.c
+ 
+ snprintf.c: ${SRCDIR}/snprintf.c
+ 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
+ 
+ undivert(3)
+ 
+ makemap.${MAN8SRC}: makemap.8
+ 	${NROFF} ${MANDOC} makemap.8 > makemap.${MAN8SRC}
+ 
  install: install-makemap install-docs
  
  install-makemap: makemap
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} makemap ${BINDIR}
  
! install-docs: makemap.${MAN8SRC}
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} makemap.${MAN8SRC} ${MAN8}/makemap.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} makemap makemap.${MAN8SRC}
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE', 
diff -cr sendmail-8.9.0/makemap/makemap.c sendmail-8.9.1/makemap/makemap.c
*** sendmail-8.9.0/makemap/makemap.c	Tue May 19 16:35:42 1998
--- sendmail-8.9.1/makemap/makemap.c	Wed Jun 24 21:48:00 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)makemap.c	8.59 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include <sys/types.h>
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)makemap.c	8.62 (Berkeley) 6/24/98";
  #endif /* not lint */
  
  #include <sys/types.h>
***************
*** 20,25 ****
--- 20,26 ----
  # include <sys/file.h>
  #endif
  #include "sendmail.h"
+ #include "pathnames.h"
  
  #ifdef NDBM
  # include <ndbm.h>
***************
*** 59,64 ****
--- 60,66 ----
  bool	DontInitGroups = TRUE;
  long	DontBlameSendmail = DBS_SAFE;
  u_char	tTdvect[100];
+ uid_t	TrustedFileUid = 0;
  
  #define BUFSIZE		1024
  
***************
*** 68,73 ****
--- 70,76 ----
  	char **argv;
  {
  	char *progname;
+ 	char *cfile;
  	bool inclnull = FALSE;
  	bool notrunc = FALSE;
  	bool allowreplace = FALSE;
***************
*** 86,91 ****
--- 89,96 ----
  	long dbcachesize = 1024 * 1024;
  	enum type type;
  	int fd;
+ 	int sff = SFF_ROOTOK|SFF_REGONLY;
+ 	struct passwd *pw;
  	union
  	{
  #ifdef NDBM
***************
*** 111,119 ****
  #ifdef NDBM
  	char pbuf[MAXNAME];
  #endif
  	static char rnamebuf[MAXNAME];	/* holds RealUserName */
- 	struct passwd *pw;
- 	int sff = SFF_ROOTOK|SFF_REGONLY;
  	struct stat std;
  #ifdef NDBM
  	struct stat stp;
--- 116,126 ----
  #ifdef NDBM
  	char pbuf[MAXNAME];
  #endif
+ #if _FFR_TRUSTED_FILE_OWNER
+ 	FILE *cfp;
+ 	char buf[MAXLINE];
+ #endif
  	static char rnamebuf[MAXNAME];	/* holds RealUserName */
  	struct stat std;
  #ifdef NDBM
  	struct stat stp;
***************
*** 122,127 ****
--- 129,135 ----
  	extern int optind;
  
  	progname = argv[0];
+ 	cfile = _PATH_SENDMAILCF;
  
  	RunAsUid = RealUid = getuid();
  	RunAsGid = RealGid = getgid();
***************
*** 137,150 ****
  	RunAsUserName = RealUserName = rnamebuf;
  
  #if _FFR_NEW_MAKEMAP_FLAGS
! #define OPTIONS		"Nc:dforsv"
  #else
! #define OPTIONS		"Ndforsv"
  #endif
  	while ((opt = getopt(argc, argv, OPTIONS)) != EOF)
  	{
  		switch (opt)
  		{
  		  case 'N':
  			inclnull = TRUE;
  			break;
--- 145,162 ----
  	RunAsUserName = RealUserName = rnamebuf;
  
  #if _FFR_NEW_MAKEMAP_FLAGS
! #define OPTIONS		"C:Nc:dforsv"
  #else
! #define OPTIONS		"C:Ndforsv"
  #endif
  	while ((opt = getopt(argc, argv, OPTIONS)) != EOF)
  	{
  		switch (opt)
  		{
+ 		  case 'C':
+ 			cfile = optarg;
+ 			break;
+ 
  		  case 'N':
  			inclnull = TRUE;
  			break;
***************
*** 220,225 ****
--- 232,296 ----
  			type = T_UNKNOWN;
  	}
  
+ #if _FFR_TRUSTED_FILE_OWNER
+ 	if ((cfp = fopen(cfile, "r")) == NULL)
+ 	{
+ 		fprintf(stderr, "mailstats: ");
+ 		perror(cfile);
+ 		exit(EX_NOINPUT);
+ 	}
+ 	while (fgets(buf, sizeof(buf), cfp) != NULL)
+ 	{
+ 		register char *b;
+ 
+ 		if ((b = strchr(buf, '\n')) != NULL)
+ 			*b = '\0';
+ 
+ 		b = buf;
+ 		switch (*b++)
+ 		{
+ 		  case 'O':		/* option */
+ 			if (strncasecmp(b, " TrustedFileOwner", 17) == 0 &&
+ 			    !(isascii(b[17]) && isalnum(b[17])))
+ 			{
+ 				b = strchr(b, '=');
+ 				if (b == NULL)
+ 					continue;
+ 				while (isascii(*++b) && isspace(*b))
+ 					continue;
+ 				if (isascii(*b) && isdigit(*b))
+ 					TrustedFileUid = atoi(b);
+ 				else
+ 				{
+ 					register struct passwd *pw;
+ 					
+ 					TrustedFileUid = 0;
+ 					pw = getpwnam(b);
+ 					if (pw == NULL)
+ 						fprintf(stderr,
+ 							"TrustedFileOwner: unknown user %s", b);
+ 					else
+ 						TrustedFileUid = pw->pw_uid;
+ 				}
+ 				
+ # ifdef UID_MAX
+ 				if (TrustedFileUid > UID_MAX)
+ 				{
+ 					syserr("TrustedFileOwner: uid value (%ld) > UID_MAX (%ld)",
+ 					       TrustedFileUid, UID_MAX);
+ 					TrustedFileUid = 0;
+ 				}
+ # endif
+ 				break;
+ 			}
+ 
+ 
+ 		  default:
+ 			continue;
+ 		}
+ 	}
+ 	(void) fclose(cfp);
+ #endif
  	switch (type)
  	{
  	  case T_ERR:
***************
*** 425,432 ****
  			exit(EX_CONFIG);
  		}
  		if (dbp.dbm != NULL &&
! 		    (filechanged(dbuf, dbm_dirfno(dbp.dbm), &std, sff) ||
! 		     filechanged(pbuf, dbm_pagfno(dbp.dbm), &stp, sff)))
  		{
  			fprintf(stderr,
  				"dbm map %s: file changed after open\n",
--- 496,503 ----
  			exit(EX_CONFIG);
  		}
  		if (dbp.dbm != NULL &&
! 		    (filechanged(dbuf, dbm_dirfno(dbp.dbm), &std) ||
! 		     filechanged(pbuf, dbm_pagfno(dbp.dbm), &stp)))
  		{
  			fprintf(stderr,
  				"dbm map %s: file changed after open\n",
***************
*** 434,439 ****
--- 505,521 ----
  			dbm_close(dbp.dbm);
  			exit(EX_CANTCREAT);
  		}
+ 		if (geteuid() == 0 && TrustedFileUid != 0)
+ 		{
+ 			if (fchown(dbm_dirfno(dbp.dbm), TrustedFileUid, -1) < 0 ||
+ 			    fchown(dbm_pagfno(dbp.dbm), TrustedFileUid, -1) < 0)
+ 			{
+ 				fprintf(stderr,
+ 					"WARNING: ownership change on %s failed: %s",
+ 					mapname, errstring(errno));
+ 			}
+ 		}
+ 
  		break;
  #endif
  
***************
*** 474,480 ****
  			fd = -1;
  			errno = dbp.db->fd(dbp.db, &fd);
  # endif
! 			if (filechanged(dbuf, fd, &std, sff))
  			{
  				fprintf(stderr,
  					"db map %s: file changed after open\n",
--- 556,562 ----
  			fd = -1;
  			errno = dbp.db->fd(dbp.db, &fd);
  # endif
! 			if (filechanged(dbuf, fd, &std))
  			{
  				fprintf(stderr,
  					"db map %s: file changed after open\n",
***************
*** 487,492 ****
--- 569,583 ----
  				exit(EX_CANTCREAT);
  			}
  			(void) (*dbp.db->sync)(dbp.db, 0);
+ 			if (geteuid() == 0 && TrustedFileUid != 0)
+ 			{
+ 				if (fchown(fd, TrustedFileUid, -1) < 0)
+ 				{
+ 					fprintf(stderr,
+ 						"WARNING: ownership change on %s failed: %s",
+ 						mapname, errstring(errno));
+ 				}
+ 			}
  		}
  		break;
  
***************
*** 524,530 ****
  			fd = -1;
  			errno = dbp.db->fd(dbp.db, &fd);
  # endif
! 			if (filechanged(dbuf, fd, &std, sff))
  			{
  				fprintf(stderr,
  					"db map %s: file changed after open\n",
--- 615,621 ----
  			fd = -1;
  			errno = dbp.db->fd(dbp.db, &fd);
  # endif
! 			if (filechanged(dbuf, fd, &std))
  			{
  				fprintf(stderr,
  					"db map %s: file changed after open\n",
***************
*** 537,542 ****
--- 628,642 ----
  				exit(EX_CANTCREAT);
  			}
  			(void) (*dbp.db->sync)(dbp.db, 0);
+ 			if (geteuid() == 0 && TrustedFileUid != 0)
+ 			{
+ 				if (fchown(fd, TrustedFileUid, -1) < 0)
+ 				{
+ 					fprintf(stderr,
+ 						"WARNING: ownership change on %s failed: %s",
+ 						mapname, errstring(errno));
+ 				}
+ 			}
  		}
  		break;
  #endif
diff -cr sendmail-8.9.0/praliases/Build sendmail-8.9.1/praliases/Build
*** sendmail-8.9.0/praliases/Build	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/praliases/Build	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/praliases/Makefile.m4 sendmail-8.9.1/praliases/Makefile.m4
*** sendmail-8.9.0/praliases/Makefile.m4	Tue May 19 16:35:47 1998
--- sendmail-8.9.1/praliases/Makefile.m4	Thu Jun  4 14:27:19 1998
***************
*** 1,7 ****
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.12	(Berkeley)	5/13/98
  #
  
  # C compiler
--- 1,7 ----
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.15	(Berkeley)	6/4/98
  #
  
  # C compiler
***************
*** 57,77 ****
  BEFORE= confBEFORE
  OBJS=	praliases.o ${OBJADD}
  
- ALL=	praliases praliases.0
- 
- all: ${ALL}
- 
- praliases: ${BEFORE} ${OBJS}
- 	${CC} -o praliases ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
- 
- undivert(3)
- 
  NROFF=	ifdef(`confNROFF', `confNROFF', `groff -Tascii')
  MANDOC=	ifdef(`confMANDOC', `confMANDOC', `-mandoc')
  
- praliases.0: praliases.8
- 	${NROFF} ${MANDOC} praliases.8 > praliases.0
- 
  INSTALL=ifdef(`confINSTALL', `confINSTALL', `install')
  BINOWN=	ifdef(`confUBINOWN', `confUBINOWN', `bin')
  BINGRP=	ifdef(`confUBINGRP', `confUBINGRP', `bin')
--- 57,65 ----
***************
*** 81,102 ****
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
  install: install-praliases install-docs
  
  install-praliases: praliases
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} praliases ${BINDIR}
  
! install-docs: praliases.0
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} praliases.${MAN8SRC} ${MAN8}/praliases.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} praliases praliases.0
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
--- 69,102 ----
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=${DESTDIR}ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
+ ALL=	praliases praliases.${MAN8SRC}
+ 
+ all: ${ALL}
+ 
+ praliases: ${BEFORE} ${OBJS}
+ 	${CC} -o praliases ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
+ 
+ undivert(3)
+ 
+ praliases.${MAN8SRC}: praliases.8
+ 	${NROFF} ${MANDOC} praliases.8 > praliases.${MAN8SRC}
+ 
  install: install-praliases install-docs
  
  install-praliases: praliases
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} praliases ${BINDIR}
  
! install-docs: praliases.${MAN8SRC}
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} praliases.${MAN8SRC} ${MAN8}/praliases.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} praliases praliases.${MAN8SRC}
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
diff -cr sendmail-8.9.0/praliases/praliases.c sendmail-8.9.1/praliases/praliases.c
*** sendmail-8.9.0/praliases/praliases.c	Tue May 19 16:35:47 1998
--- sendmail-8.9.1/praliases/praliases.c	Thu Jun 25 23:25:04 1998
***************
*** 17,23 ****
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)praliases.c	8.16 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #if !defined(NDBM) && !defined(NEWDB)
--- 17,23 ----
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)praliases.c	8.17 (Berkeley) 6/25/98";
  #endif /* not lint */
  
  #if !defined(NDBM) && !defined(NEWDB)
***************
*** 28,34 ****
  #ifdef NDBM
  # include <ndbm.h>
  #endif
! #define NOT_SENDMAIL
  #include <sendmail.h>
  #ifdef NEWDB
  # include <db.h>
--- 28,36 ----
  #ifdef NDBM
  # include <ndbm.h>
  #endif
! #ifndef NOT_SENDMAIL
! # define NOT_SENDMAIL
! #endif
  #include <sendmail.h>
  #ifdef NEWDB
  # include <db.h>
diff -cr sendmail-8.9.0/rmail/Build sendmail-8.9.1/rmail/Build
*** sendmail-8.9.0/rmail/Build	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/rmail/Build	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/rmail/Makefile.m4 sendmail-8.9.1/rmail/Makefile.m4
*** sendmail-8.9.0/rmail/Makefile.m4	Tue May 19 16:35:51 1998
--- sendmail-8.9.1/rmail/Makefile.m4	Thu Jun 18 10:47:53 1998
***************
*** 1,7 ****
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.12	(Berkeley)	5/13/98
  #
  
  # C compiler
--- 1,7 ----
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.16	(Berkeley)	6/18/98
  #
  
  # C compiler
***************
*** 50,73 ****
  BEFORE= snprintf.c confBEFORE
  OBJS=	rmail.o snprintf.o ${OBJADD}
  
- ALL=	rmail rmail.0
- 
- all: ${ALL}
- 
- rmail: ${BEFORE} ${OBJS}
- 	${CC} -o rmail ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
- 
- snprintf.c: ${SRCDIR}/snprintf.c
- 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
- 
- undivert(3)
- 
  NROFF=	ifdef(`confNROFF', `confNROFF', `groff -Tascii')
  MANDOC=	ifdef(`confMANDOC', `confMANDOC', `-mandoc')
  
- rmail.0: rmail.8
- 	${NROFF} ${MANDOC} rmail.8 > rmail.0
- 
  INSTALL=ifdef(`confINSTALL', `confINSTALL', `install')
  BINOWN=	ifdef(`confUBINOWN', `confUBINOWN', `bin')
  BINGRP=	ifdef(`confUBINGRP', `confUBINGRP', `bin')
--- 50,58 ----
***************
*** 77,98 ****
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
! install: install-rmail install-docs
  
  install-rmail: rmail
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} rmail ${BINDIR}
  
! install-docs: rmail.0
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} rmail.${MAN8SRC} ${MAN8}/rmail.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} rmail rmail.0
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
--- 62,103 ----
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=${DESTDIR}ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
! ALL=	rmail rmail.${MAN8SRC}
! 
! all: ${ALL}
! 
! rmail: ${BEFORE} ${OBJS}
! 	${CC} -o rmail ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
! 
! snprintf.c: ${SRCDIR}/snprintf.c
! 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
! 
! undivert(3)
! 
! rmail.${MAN8SRC}: rmail.8
! 	${NROFF} ${MANDOC} rmail.8 > rmail.${MAN8SRC}
! 
! install:
! 	@echo "NOTE: This version of rmail is not suited for some operating"
! 	@echo "      systems.  You can force the install using"
! 	@echo "      '${MAKE} force-install'."
! 
! force-install: install-rmail install-docs
  
  install-rmail: rmail
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} rmail ${BINDIR}
  
! install-docs: rmail.${MAN8SRC}
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} rmail.${MAN8SRC} ${MAN8}/rmail.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} rmail rmail.${MAN8SRC}
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
